package com.ruoyi.system.utils;

import com.alibaba.fastjson2.JSONObject;
import com.ruoyi.common.core.utils.JwtUtils;
import java.io.IOException;
import java.time.LocalDateTime;
import java.time.ZoneId;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import okhttp3.FormBody;
import okhttp3.MediaType;
import okhttp3.OkHttpClient;
import okhttp3.Request;
import okhttp3.RequestBody;
import okhttp3.Response;

public class RequestUtil {
   private static final MediaType JSON = MediaType.parse("application/json; charset=utf-8");
   private static final MediaType XML = MediaType.parse("application/xml; charset=utf-8");
   public static final String USER_AGENT = "Mozilla/5.0 (Windows NT 6.1; WOW64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/40.0.2214.111 Safari/537.36";

   public static void main(String[] args) {
      Map<String, String> params = new HashMap();
      params.put("order_id", "92546");
      String res = (new RequestUtil()).doPostFormByToken("https://ceshi-c-wp.htuseradmin.xyz/wp-content/plugins/node/success.php", params);
      System.out.println(res);
   }

   public String getIpContry(String url, String key, String ip, String agent) {
      OkHttpClient client = new OkHttpClient();
      Request request = (new Request.Builder()).url(url + "20230615_iM5b2flma").addHeader("escloak-key", key).addHeader("User-Agent", agent).post(RequestBody.create(JSON, getJsonBody(ip, agent))).build();

      try {
         Response response = client.newCall(request).execute();

         String var8;
         label58: {
            try {
               if (response.isSuccessful()) {
                  var8 = response.body().string();
                  break label58;
               }

               System.out.println("请求失败: " + response);
            } catch (Throwable var11) {
               if (response != null) {
                  try {
                     response.close();
                  } catch (Throwable var10) {
                     var11.addSuppressed(var10);
                  }
               }

               throw var11;
            }

            if (response != null) {
               response.close();
            }

            return null;
         }

         if (response != null) {
            response.close();
         }

         return var8;
      } catch (IOException var12) {
         IOException e = var12;
         e.printStackTrace();
         return null;
      }
   }

   private static String getJsonBody(String ip, String userAgent) {
      return (new JSONObject()).fluentPut("visitor", (new JSONObject()).fluentPut("remote_addr", ip).fluentPut("v", 4).fluentPut("xi", 1).fluentPut("lp_url", "http://" + ip)).fluentPut("browser_headers", (new JSONObject()).fluentPut("user_vvagent", userAgent).fluentPut("host", ip)).fluentPut("client_server", (new JSONObject()).fluentPut("REMOTE_ADDR", ip).fluentPut("SERVER_ADDR", ip)).toString();
   }

   public String doGet(String url) {
      return this.doGet(url, (Map)null, (Map)null);
   }

   public byte[] doGetByte(String url) {
      return this.doGetByte(url, (Map)null, (Map)null);
   }

   public String doPost(String url) {
      return this.doPost(url, (Map)null, (Map)null);
   }

   public String doGetToParams(String url, Map<String, String> params) {
      return this.doGet(url, params, (Map)null);
   }

   public String doGetToHeaders(String url, Map<String, String> headers) {
      return this.doGet(url, (Map)null, headers);
   }

   public String doGet(String url, Map<String, String> params, Map<String, String> headers) {
      StringBuilder sb = new StringBuilder(url);
      Iterator var6;
      String header;
      if (params != null && params.keySet().size() > 0) {
         boolean firstFlag = true;
         var6 = params.keySet().iterator();

         while(var6.hasNext()) {
            header = (String)var6.next();
            if (firstFlag) {
               sb.append("?").append(header).append("=").append((String)params.get(header));
               firstFlag = false;
            } else {
               sb.append("&").append(header).append("=").append((String)params.get(header));
            }
         }
      }

      Request.Builder builder = new Request.Builder();
      if (headers != null && !headers.isEmpty()) {
         var6 = headers.keySet().iterator();

         while(var6.hasNext()) {
            header = (String)var6.next();
            builder.addHeader(header, (String)headers.get(header));
         }
      }

      Request request = builder.url(sb.toString()).build();
      return this.executeBody(request);
   }

   public byte[] doGetByte(String url, Map<String, String> params, Map<String, String> headers) {
      StringBuilder sb = new StringBuilder(url);
      Iterator var6;
      String header;
      if (params != null && params.keySet().size() > 0) {
         boolean firstFlag = true;
         var6 = params.keySet().iterator();

         while(var6.hasNext()) {
            header = (String)var6.next();
            if (firstFlag) {
               sb.append("?").append(header).append("=").append((String)params.get(header));
               firstFlag = false;
            } else {
               sb.append("&").append(header).append("=").append((String)params.get(header));
            }
         }
      }

      Request.Builder builder = new Request.Builder();
      if (headers != null && !headers.isEmpty()) {
         var6 = headers.keySet().iterator();

         while(var6.hasNext()) {
            header = (String)var6.next();
            builder.addHeader(header, (String)headers.get(header));
         }
      }

      Request request = builder.url(sb.toString()).build();
      return this.executeByte(request);
   }

   public String doPostForm(String url, Map<String, String> params) {
      FormBody.Builder builder = new FormBody.Builder();
      if (params != null && params.keySet().size() > 0) {
         Iterator var4 = params.keySet().iterator();

         while(var4.hasNext()) {
            String key = (String)var4.next();
            builder.add(key, (String)params.get(key));
         }
      }

      Request request = (new Request.Builder()).url(url).post(builder.build()).build();
      return this.execute(request);
   }

   public String doPostFormByToken(String url, Map<String, String> params) {
      Map<String, String> headers = new HashMap();
      headers.put("Authorization", this.getToken(url));
      return this.doPost(url, params, headers);
   }

   public String doPostByToken(String url, Map<String, String> params, Map<String, String> headers) {
      if (headers == null) {
         headers = new HashMap();
      }

      ((Map)headers).put("Authorization", this.getToken(url));
      return this.doPost(url, params, (Map)headers);
   }

   public String doPostJsonByToken(String url, String json) {
      Map<String, String> headers = new HashMap();
      headers.put("Authorization", this.getToken(url));
      return this.executePost(url, json, JSON, headers);
   }

   public String doPost(String url, Map<String, String> params, Map<String, String> headers) {
      FormBody.Builder builder = new FormBody.Builder();
      if (params != null && params.keySet().size() > 0) {
         Iterator var5 = params.keySet().iterator();

         while(var5.hasNext()) {
            String key = (String)var5.next();
            builder.add(key, (String)params.get(key));
         }
      }

      Request.Builder requestBuilder = new Request.Builder();
      if (headers != null && !headers.isEmpty()) {
         Iterator var9 = headers.keySet().iterator();

         while(var9.hasNext()) {
            String header = (String)var9.next();
            requestBuilder.addHeader(header, (String)headers.get(header));
         }
      }

      Request request = requestBuilder.url(url).post(builder.build()).build();
      return this.execute(request);
   }

   public String doPostJson(String url, String json) {
      return this.executePost(url, json, JSON, new HashMap());
   }

   public String doPostJson(String url, String json, Map<String, String> headers) {
      RequestBody requestBody = RequestBody.create(JSON, json);
      Request.Builder builder = new Request.Builder();
      if (headers != null && !headers.isEmpty()) {
         Iterator var6 = headers.keySet().iterator();

         while(var6.hasNext()) {
            String header = (String)var6.next();
            builder.addHeader(header, (String)headers.get(header));
         }
      }

      Request request = builder.url(url).post(requestBody).build();
      return this.execute(request);
   }

   public String doPostXml(String url, String xml) {
      return this.executePost(url, xml, XML, new HashMap());
   }

   public String executePost(String url, String data, MediaType contentType, Map<String, String> headers) {
      RequestBody requestBody = RequestBody.create(contentType, data);
      Request.Builder requestBuilder = new Request.Builder();
      if (headers != null && !headers.isEmpty()) {
         Iterator var7 = headers.keySet().iterator();

         while(var7.hasNext()) {
            String header = (String)var7.next();
            requestBuilder.addHeader(header, (String)headers.get(header));
         }
      }

      Request request = requestBuilder.url(url).post(requestBody).build();
      return this.execute(request);
   }

   public String execute(Request request) {
      Response response = null;

      try {
         OkHttpClient client = (new OkHttpClient.Builder()).readTimeout(120L, TimeUnit.SECONDS).build();
         response = client.newCall(request).execute();
         if (response.isSuccessful()) {
            String var4 = response.body().string();
            return var4;
         }
      } catch (Exception var8) {
         Exception e = var8;
         e.printStackTrace();
      } finally {
         if (response != null) {
            response.close();
         }

      }

      return "";
   }

   public String executeBody(Request request) {
      Response response = null;

      try {
         response = (new OkHttpClient()).newCall(request).execute();
         if (response.body() != null) {
            String var9 = response.body().string();
            return var9;
         }
      } catch (Exception var7) {
         Exception e = var7;
         e.printStackTrace();
      } finally {
         if (response != null) {
            response.close();
         }

      }

      return "";
   }

   public String executeHttp(String url) {
      Response response = null;

      String var9;
      try {
         response = (new OkHttpClient()).newCall((new Request.Builder()).url(url).build()).execute();
         if (response.body() == null) {
            return "";
         }

         var9 = response.body().string();
      } catch (Exception var7) {
         Exception e = var7;
         e.printStackTrace();
         return "";
      } finally {
         if (response != null) {
            response.close();
         }

      }

      return var9;
   }

   public byte[] executeByte(Request request) {
      Response response = null;

      try {
         response = (new OkHttpClient()).newCall(request).execute();
         if (response.isSuccessful()) {
            byte[] var9 = response.body().bytes();
            return var9;
         }
      } catch (Exception var7) {
         Exception e = var7;
         e.printStackTrace();
      } finally {
         if (response != null) {
            response.close();
         }

      }

      return null;
   }

   public String getToken(String url) {
      Map<String, Object> claimsMap = new HashMap();
      claimsMap.put("iss", "https://core.htadminusre.xyz");
      claimsMap.put("aud", url);
      claimsMap.put("iat", LocalDateTime.now().atZone(ZoneId.systemDefault()).toInstant().toEpochMilli() / 1000L);
      claimsMap.put("nbf", LocalDateTime.now().atZone(ZoneId.systemDefault()).toInstant().toEpochMilli() / 1000L);
      claimsMap.put("exp", LocalDateTime.now().plusMinutes(1L).atZone(ZoneId.systemDefault()).toInstant().toEpochMilli() / 1000L);
      return JwtUtils.createToken(claimsMap);
   }
}
